<?php

/**
*
* @package memberships in memberlist
* @copyright (c) 2012 javiexin
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

/**
* @ignore
*/
if (!defined('IN_PHPBB'))
{
	exit;
}

/**
* @package acp
*/
class acp_memberships
{
	var $u_action;

	function main($id, $mode)
	{
		global $db, $user, $auth, $template, $cache;
		global $config, $phpbb_root_path, $phpbb_admin_path, $phpEx;

		$user->add_lang('mods/info_acp_membership');
		$user->add_lang('acp/groups');
		$this->tpl_name = 'acp_membership';
		$this->page_title = $user->lang['MEMBERSHIP_TITLE'];
		add_form_key('acp_membership');
		$submit = (isset($_POST['submit'])) ? true : false;
		$action = request_var('action', '');
		$group_id = request_var('g', 0);

		include($phpbb_root_path . 'includes/functions_user.' . $phpEx);

		$group_list = array_map('intval', explode(',', $config['group_memberships']));
		
		if ($action != '')
		{
			switch ($action)
			{
				case 'set_config':
					set_config('group_memberships_enabled', request_var('memberships_enable', false));
				break;
				
				case 'add':
					$group_list = array_unique(array_merge($group_list, array($group_id)));
				break;

				case 'delete':
					$group_list = array_diff($group_list, array($group_id));
				break;

				case 'move_up':
					$gl = array();
					for ($i=0; $i < count($group_list)-1; $i++) 
					{
						$gl[$i] = ($group_list[$i+1] == $group_id) ? $group_list[$i+1] : (($group_list[$i] == $group_id) ? $group_list[$i-1] : $group_list[$i]);
					}
					$gl[$i] = ($group_list[$i] == $group_id) ? $group_list[$i-1] : $group_list[$i];
					$group_list = array_unique($gl);
					unset($gl);
				break;

				case 'move_down':
					$gl = array();
					$gl[0] = ($group_list[0] == $group_id) ? $group_list[1] : $group_list[0];
					for ($i=1; $i < count($group_list); $i++) 
					{
						$gl[$i] = ($group_list[$i-1] == $group_id) ? $group_list[$i-1] : (($group_list[$i] == $group_id) ? $group_list[$i+1] : $group_list[$i]);
					}
					$group_list = array_unique($gl);
					unset($gl);
				break;
			}
			if ($action != 'set_config')
			{
				set_config('group_memberships', implode(',', array_map('strval', $group_list)));
			}
			trigger_error($user->lang['MEMBERSHIP_CONFIG_SAVED'] . adm_back_link($this->u_action));
		}

		$group_ary = visible_groups();

		$s_group_select = '';
		$group_table = array();
		foreach ($group_ary as $row)
		{
			$group_name = ($row['group_type'] == GROUP_SPECIAL) ? $user->lang['G_' . $row['group_name']] : $row['group_name'];
			$row['group_name'] = $group_name;
			if (in_array($row['group_id'],$group_list))
			{
				$group_table[$row['group_id']] = $row;
			}
			else
			{
				$s_group_select .= '<option value="' . (int) $row['group_id'] . '">' . $group_name . '</option>';
			}
		};
		
		$group_type_language = array(
			GROUP_OPEN		=> 'GROUP_REQUEST',
			GROUP_CLOSED	=> 'GROUP_CLOSED',
			GROUP_HIDDEN	=> 'GROUP_HIDDEN',
			GROUP_FREE		=> 'GROUP_OPEN',
			GROUP_SPECIAL	=> 'GROUP_SPECIAL',
		);

		foreach ($group_list as $group_id)
		{
			if (isset($group_table[$group_id]))
			{
				$row = $group_table[$group_id];
				$template->assign_block_vars('membership', array(
					'GROUP_NAME' => $row['group_name'],
					'GROUP_COLOUR' => ($row['group_colour']) ? ' style="color: #' . $row['group_colour'] . '"' : '',
					'GROUP_TYPE' => $user->lang[$group_type_language[$row['group_type']]],

					'U_MOVE_DOWN' => "{$this->u_action}&amp;action=move_down&amp;g=" . $row['group_id'],
					'U_MOVE_UP' => "{$this->u_action}&amp;action=move_up&amp;g=" . $row['group_id'],
					'U_DELETE' => "{$this->u_action}&amp;action=delete&amp;g=" . $row['group_id'],
				));
			}
		}

		$template->assign_vars(array(
			'MEMBERSHIP_VERSION'		=> 'v' . $config['group_memberships_version'],
			'ENABLE_MEMBERSHIPS'		=> $config['group_memberships_enabled'],

			'S_GROUP_SELECT'			=> $s_group_select,

			'U_ACTION'				=> $this->u_action,
		));
	}
}

?>